# ---------------------------------------------
# Licensed Materials - Property of IBM
# (C) Copyright IBM Corporation 2023
# ---------------------------------------------




###create the podman/docker alias
###source ./createPodmanAlias.sh
###createPodmanAlias


###create the podman/docker alias
if [[ $TA_LOCAL_TEMP_PODMAN_INSTALL = true ]]; then
  shopt -s expand_aliases
  source ./.podman_config
fi

###get the container ID's
ui=$(docker ps -a | grep transformation-advisor-ui | awk '{print $1}')
couch=$(docker ps -a | grep transformation-advisor-db | awk '{print $1}')
server=$(docker ps -a | grep transformation-advisor-server | awk '{print $1}')
neo4j=$(docker ps -a | grep transformation-advisor-neo4j | awk '{print $1}')


mkdir -p ../taLocalInfo

date=`date +"%Y%m%d_%H%M%S"`

#######get the docker / podman version

echo "Get the docker / podman version"
docker version >> ../taLocalInfo/taLocalInfo_$date.txt
echo "done"
echo ""
echo "--------------------------" >> ../taLocalInfo/taLocalInfo_$date.txt

####get TA images
echo "" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get TA images"
echo "Get TA images" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "--------------------------" >> ../taLocalInfo/taLocalInfo_$date.txt
docker images >> ../taLocalInfo/taLocalInfo_$date.txt
echo "done"
echo ""

####get TA running containers 
echo "" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the TA running containers" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "--------------------------" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the TA containers"

docker ps -a >> ../taLocalInfo/taLocalInfo_$date.txt
echo "done"
echo ""


####get the TA server env variable
echo "" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the TA server env variable" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "--------------------------" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the TA server env variable"

docker exec -ti $server env | grep TA  >> ../taLocalInfo/taLocalInfo_$date.txt
echo "done"
echo ""
 
####get the TA ui env variable
echo "" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the TA ui env variable" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "--------------------------" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the TA ui env variable"

docker exec -ti $ui env | grep TA  >> ../taLocalInfo/taLocalInfo_$date.txt
echo "done"
echo ""

####get the TA couchDB env variable
echo "" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the TA couchDB env variable" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "--------------------------" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the TA couchDB env variable"

docker exec -ti $couch env | grep COUCH  >> ../taLocalInfo/taLocalInfo_$date.txt
echo "done"
echo ""


####get the TA neo4j env variable
echo "" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the TA neo4j env variable" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "--------------------------" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the TA neo4j env variable"

docker exec -ti $neo4j env | grep NEO  >> ../taLocalInfo/taLocalInfo_$date.txt
echo "done"
echo ""

####get the TA server log
echo "" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the TA server log" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "--------------------------" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the TA server log"

docker cp $server:/logs/messages.log ../taLocalInfo/message.log_$date.txt
echo "done"
echo ""

if [[ -e "/etc/redhat-release" ]] ; 
then
####get the linux version 
echo "" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the linux version" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "--------------------------" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the the linux version"

cat /etc/redhat-release  >> ../taLocalInfo/taLocalInfo_$date.txt
echo "done"
echo ""
fi

####get the number of CPU 
echo "" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the number of CPUs" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "--------------------------" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the number of CPUs"

if uname -s | grep 'Darwin' ;
then
 sysctl hw.ncpu | awk '{print $2}' >> ../taLocalInfo/taLocalInfo_$date.txt
else
 cat /proc/cpuinfo | grep proc | wc -l  >> ../taLocalInfo/taLocalInfo_$date.txt
fi
echo "done"
echo ""

####get the memory 
echo "" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the memory info" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "--------------------------" >> ../taLocalInfo/taLocalInfo_$date.txt
echo "Get the memory info"

if uname -s | grep 'Darwin' ;
then
echo MemTotal: `sysctl hw.memsize | awk '{print $2}'` >> ../taLocalInfo/taLocalInfo_$date.txt
else
grep MemTotal /proc/meminfo  >> ../taLocalInfo/taLocalInfo_$date.txt
fi
echo "done"
echo ""


if uname -a | grep "Ubuntu" ;
then
        ####get the ubuntu version
        echo "" >> ../taLocalInfo/taLocalInfo_$date.txt
        echo "Get the Ubuntu version" >> ../taLocalInfo/taLocalInfo_$date.txt
        echo "--------------------------" >> ../taLocalInfo/taLocalInfo_$date.txt
        echo "Get the the Ubuntu version"

        lsb_release -a  >> ../taLocalInfo/taLocalInfo_$date.txt
        echo "done"
        echo ""
fi

echo "----------------------------------------------------------------------------------"
echo ""
echo "TA Local Debug log is available at taLocalInfo/taLocalInfo_$date.txt"
echo "TA Local message log is available at taLocalInfo/message.log_$date.txt"
echo ""
echo "----------------------------------------------------------------------------------"
